import { defineComponent as U, ref as a, computed as r, resolveComponent as h, openBlock as z, createElementBlock as V, normalizeClass as j, normalizeStyle as w, createElementVNode as C, createVNode as f, unref as k, mergeProps as R, withCtx as u, renderSlot as m, createBlock as D } from "vue";
import { ElTable as I, ElPagination as M } from "element-plus";
const q = /* @__PURE__ */ U({
  __name: "ElPaginationTable",
  props: {
    class: {},
    style: { type: [Boolean, null, String, Object, Array] },
    data: { default: () => [] },
    total: { default: () => 0 },
    dataAtOnce: { type: Boolean, default: () => !1 },
    pageSize: { default: () => 10 },
    currentPage: { default: () => 1 },
    pageCount: { default: () => 1 }
  },
  emits: [
    "update:current-page",
    "update:page-size",
    "size-change",
    "current-change"
  ],
  setup(n, { expose: p, emit: s }) {
    const t = n, o = s, O = a(), v = a(), A = a(), b = a(), P = a(), g = a(1), i = r({
      get: () => t.dataAtOnce ? g.value : t.currentPage,
      set: (e) => {
        o("update:current-page", e);
      }
    }), y = a(10), l = r({
      get: () => t.dataAtOnce ? y.value : t.pageSize,
      set: (e) => {
        o("update:page-size", e);
      }
    }), S = r(() => {
      var e;
      return t.dataAtOnce ? (e = t.data) == null ? void 0 : e.slice(
        (i.value - 1) * l.value,
        (i.value - 1) * l.value + l.value
      ) : t.data;
    }), _ = r(() => {
      var e;
      return t.dataAtOnce ? (e = t.data) == null ? void 0 : e.length : t.total;
    }), E = r(() => Math.ceil(_.value / l.value)), T = (e) => {
      t.dataAtOnce ? (console.log("size-change", "data-at-once", e), y.value = e, g.value = 1) : (console.log("size-change"), o("size-change", e));
    }, $ = (e) => {
      t.dataAtOnce ? (console.log("current-change", "data-at-once", e), g.value = e) : (console.log("current-change", e), o("current-change", e));
    };
    return p({
      tableRef: v,
      paginationRef: b
    }), (e, c) => {
      const B = h("el-empty"), N = h("el-scrollbar");
      return z(), V("div", {
        ref_key: "paginationTableRef",
        ref: O,
        class: j(["el-pagination-table", t.class]),
        style: w(t.style)
      }, [
        C("div", {
          ref_key: "tableContainerRef",
          ref: A,
          class: "el-pagination-table-table"
        }, [
          f(k(I), R({
            ref_key: "tableRef",
            ref: v
          }, e.$attrs, {
            height: "100%",
            data: S.value
          }), {
            empty: u(() => [
              e.$slots.empty ? m(e.$slots, "empty", { key: 0 }, void 0, !0) : (z(), D(B, {
                key: 1,
                "image-size": 100
              }))
            ]),
            append: u(() => [
              m(e.$slots, "append", {}, void 0, !0)
            ]),
            default: u(() => [
              m(e.$slots, "default", {}, void 0, !0)
            ]),
            _: 3
          }, 16, ["data"])
        ], 512),
        C("div", {
          ref_key: "paginationContainerRef",
          ref: P,
          class: "el-pagination-table-pagination"
        }, [
          f(N, { class: "el-pagination-table-pagination-scrollbar" }, {
            default: u(() => [
              f(k(M), R({
                ref_key: "paginationRef",
                ref: b
              }, e.$attrs, {
                "current-page": i.value,
                "onUpdate:currentPage": c[0] || (c[0] = (d) => i.value = d),
                "page-size": l.value,
                "onUpdate:pageSize": c[1] || (c[1] = (d) => l.value = d),
                "page-count": E.value,
                total: _.value,
                onSizeChange: T,
                onCurrentChange: $
              }), null, 16, ["current-page", "page-size", "page-count", "total"])
            ]),
            _: 1
          })
        ], 512)
      ], 6);
    };
  }
}), x = (n, p) => {
  const s = n.__vccOpts || n;
  for (const [t, o] of p)
    s[t] = o;
  return s;
}, F = /* @__PURE__ */ x(q, [["__scopeId", "data-v-592e189e"]]), J = {
  install(n) {
    n.component("ElPaginationTable", F);
  }
};
export {
  F as ElPaginationTable,
  J as default
};
